# OOPS

Object oriented pseudo syntax is another esoteric programming language.

## oopsc

The oops compiler compiles oops source code to a native executable.

### Approaches

- [`nom`](https://docs.rs/nom): parser combinator, meaning we don't write grammar and generate code from
  it but we write many small functions that magically work together. Sounds cool
  but coming from a university course with antlr and ply I don't get it.
- [`pest`](https://pest.rs/): weird grammar syntax but seems like a very
  professional choice.
- [`lalrpop`](https://github.com/lalrpop/lalrpop): seems most similar to ply and
  antlr, but feels confusing from the first glance.

`pest` seems the most mature and usable for a rust project, there is even a
list of pretty popular stuff written with it [here](https://github.com/pest-parser/pest#projects-using-pest).
